<?php

class PostBox
{
	static function SendSMS( $from, $to, $text, $test = false )
	{
		$success = false;

		if ( !$test && SENDUSERMAIL )
		{
			$to = self::Internationalise( $to );

            echo "SENDUSEREMAIL == TRUE, sending to " . $to . "\n";
		}
		else
		if ( !$test && SENDDEMOMAIL )
		{
			$to = self::Internationalise( DEMO_MOBILE );
			$text = "Demo: " . $text;
		}
		else
		{
			$to = self::Internationalise( TEST_MOBILE );
			$text = "Test: " . $text;

            echo "SENDUSEREMAIL == FALSE, sending to " . $to . "\n";
		}

		if ( USE_WHOLESALESMS )
		{
			$api = new TransmitSMSAPI( USE_WHOLESALESMS_KEY, USE_WHOLESALESMS_SECRET );
			
			$response = $api->sendSMS( $text, $to, $from );

			if ( "SUCCESS" == $response->error->code )
			{
				$success = $response->message_id;
			}
			else
			{
				var_dump( $response );
			}
		}

		return $success;
	}


	static function SendEmail1( $sender, $from, $to, $subject, $plain, $html, $bcc, $attachments = false, $test = false )
	{
        $from = new SendGrid\Email(null, "test@example.com");
        $subject = "Hello World from the SendGrid PHP Library";
        $to = new SendGrid\Email(null, "daniel@icuro.com.au");
        $content = new SendGrid\Content("text/plain", "some text here");
        $mail = new SendGrid\Mail($from, $subject, $to, $content);
        $to = new SendGrid\Email(null, "test2@example.com");
        $mail->personalization[0]->addTo($to);

        $apiKey = USE_SENDGRID_APIKEY;
        $sg = new \SendGrid($apiKey);
        $response = $sg->client->mail()->send()->post($mail);
        echo $response->statusCode();
        echo $response->body();
        print_r($response->headers());
    }

	static function SendEmail2( $sender, $from, $to, $subject, $plain, $html, $bcc, $attachments = false, $test = false )
	{
        $subject = "Hello World from the SendGrid PHP Library";
        $from    = new SendGrid\Email(null, "team@example.com");
        $to      = new SendGrid\Email(null, "daniel@icuro.com.au");
        $content = new SendGrid\Content("text/plain", "some text here");

        $mail = new SendGrid\Mail();
        $mail->setFrom   ( $from    );
        $mail->setSubject( $subject );
        $mail->addContent( $content );
        
        $personalization = new SendGrid\Personalization();
        $personalization->addTo( $to );

        $mail->addPersonalization( $personalization );

        $apiKey = USE_SENDGRID_APIKEY;
        $sg = new \SendGrid($apiKey);
        $response = $sg->client->mail()->send()->post($mail);
        echo $response->statusCode();
        echo $response->body();
        print_r($response->headers());
    }

	static function SendEmail( $sender, $from, $to, $subject, $plain, $html, $bcc, $attachments = false, $test = false )
	{
        $success = false;
    
        $from = new SendGrid\Email( null, $from );
        $mail = new SendGrid\Mail();
        $mail->setFrom   ( $from    );
        $mail->setSubject( $subject );

        if ( $plain )
        {
            $mail->addContent( new SendGrid\Content( "text/plain", $plain ) );
        }

        if ( $html )
        {
            $mail->addContent( new SendGrid\Content( "text/html", $html ) );
        }
 
        if ( $attachments )
        {
            foreach ( $attachments as $a )
            {
                $attachment = new SendGrid\Attachment();
                $attachment->setContent    ( $a["attachment_content64"  ] );
                $attachment->setType       ( $a["attachment_type"       ] );
                $attachment->setFilename   ( $a["attachment_filename"   ] );
                $attachment->setDisposition( $a["attachment_disposition"] );
                $attachment->setContentId  ( $a["attachment_content_id" ] );
            
                $mail->addAttachment( $attachment );
            }
        }

        if ( $test || !SENDUSERMAIL )
        {
            //echo "SENDUSEREMAIL == FALSE, sending to " . TEST_EMAIL . " (instead of $to)\n";
            $email_to = new SendGrid\Email( null, TEST_EMAIL );
        }
        else
		{
            $address = new EmailAddress( $to );
       
            if ( !string_contains( $to, "@" ) || !$address->isValid( new NullPrinter() ) )
            {
                $to = self::DetermineFailOverEmailAddress( $to, $address );
            }
            $email_to = new SendGrid\Email( null, $to );
            //echo "SENDUSEREMAIL == TRUE, sending to " . $to . "\n";
        }
        
        $personalization = new SendGrid\Personalization();
        $personalization->addTo( $email_to );

        if ( ! $bcc )
        {
            echo "No BCCs!" . "\n";
        }
        else
        {
            $BCCs = explode( ',', $bcc );
            
            foreach ( $BCCs as $b )
            {
                $email_bcc = new SendGrid\Email( null, $b );

                $personalization->addBcc( $email_bcc );
            }
        }

        $mail->addPersonalization( $personalization );

        $apiKey = USE_SENDGRID_APIKEY;
        $sg = new \SendGrid($apiKey);
        $response = $sg->client->mail()->send()->post($mail);

        if ( "202" != $response->statusCode() )
        {
            echo $response->statusCode();
            echo $response->body();
            print_r($response->headers());
        }
        else
        {
            $success = ( $test || !SENDUSERMAIL ) ? "T" : "#";
        }
        
        return $success;
    }

	static function SendEmailX( $sender, $from, $to, $subject, $plain, $html, $bcc, $attachments = false, $test = false )
	{
		$success = false;

		$to      = self::StandardiseEmailAddress( $to );
		$message = html_entity_decode( $plain, ENT_QUOTES );
	
		if ( defined( "USE_SENDGRID" ) )
		{
			try
			{
				$sendgrid  = new SendGrid( USE_SENDGRID_APIKEY );
				$mail      = new SendGrid\Mail();
                $addresses = new SendGrid\Personalization();

				if ( !$test && SENDUSERMAIL )
				{
					$address = new EmailAddress( $to );
					
					if ( !string_contains( $to, "@" ) || !$address->isValid( new NullPrinter() ) )
					{
						$to = self::DetermineFailOverEmailAddress( $to, $address );
					}

                    $addresses->addTo( new SendGrid\Email( "Test", $to ) );
					echo "SENDUSEREMAIL == TRUE, sending to " . $to . "\n";

					if ( defined( "BCCUSERMAIL") && BCCUSERMAIL )
					{
                        $addresses->addBcc( new SendGrid\Email( "BCC", TECH_EMAIL ) );
					}

                    if ( $bcc )
                    {
                        $addresses->addBcc( new SendGrid\Email( "BCC", $bcc ) );
                    }
				}
				else
				{
					echo "SENDUSEREMAIL == FALSE, sending to " . TECH_EMAIL . " (instead of $to)\n";

					$addresses->addTo( new SendGrid\Email( "Tech", TECH_EMAIL ) );
				}
                $addresses->setSubject( $subject );

                $mail->addPersonalization( $addresses );
                $mail->setFrom( new SendGrid\Email( $sender, $from ) );

                //if ( $message )
                {
                    $plain = new Content( "text/plain", "Some text here" );//$message );
                    $mail->addContent( $plain );
                }
                
				//if ( $html )
                {
                    $html_content = new Content( "text/html", "<html><body>some text here</body></html>" );// $html );
                    $mail->addContent( $html_content );
                }
                
                if ( false )//$attachments )
                {
                    foreach ( $attachments as $a )
                    {
                        $attachment = new SendGrid\Attachment();
                        $attachment->setContent    ( base64_decode( $a["attachment_content64"  ] ) );
                        $attachment->setType       (                $a["attachment_type"       ]   );
                        $attachment->setFilename   (                $a["attachment_filename"   ]   );
                        $attachment->setDisposition(                $a["attachment_disposition"]   );
                        $attachment->setContentId  (                $a["attachment_content_id" ]   );
                    
                        $mail->addAttachment( $attachment );
                    }
                }

                try
                {
                    $response = $sendgrid->client->mail()->send()->post( $mail );

                    if ( $response )
                    {
                        echo $response->statusCode() . "\n";

                        if ( $response->statusCode() == "200" )
                        {
                            $success = True;
                        }
                        else
                        {
                            echo var_export( $response, true ) . "\n";
                        }
                    }
                }
                catch ( Exception $e )
                {
                    echo $e->getMessage() . " " . $response->statusCode() . "\n";
                    $success = False;
                }
			}
			catch ( Exception $ex )
			{
				echo "Exception thrown from SendGrid: " . $ex->getMessage() . "\n";
			}
		}
		else
		{
			echo "SendGrid is not configured.";
		}
		return $success;
	}

	static function SendMessageTest( $appname, $from, $to, $subject, $message, $html, $out )
	{
		$out->println( "$appname" );
		$out->println( "$from"    );
		$out->println( "$to"      );
		$out->println( "$subject" );
		$out->println( "$message" );
		$out->println( "$html"    );
		
		return false;
	}

	static function DetermineFailoverEmailAddress( $to, $address )
	{
		if ( defined( "BOGUS_EMAIL" ) )
		{
			echo "Bogus email detected ($to), sending to " . BOGUS_EMAIL . " - $address->error\n";
			$to = BOGUS_EMAIL;
		}
		else
		{
			echo "Bogus email detected ($to), ignoring as BOGUS_EMAIL is not defined - $address->error\n";
			$to = "";
		}

		return $to;
	}

	static function Internationalise( $to )
	{
		if ( ! string_startsWith( $to, "+" ) )
		{
			$to = str_replace( ' ', '', $to );
		
			if ( (10 == strlen( $to )) && string_startsWith( $to, "0" ) )
			{
				$to = "+61" . substr( $to, 1 );
			}
		}
		return $to;
	}
	
	static function StandardiseEmailAddress( $email_address )
	{
		$standard = $email_address;
		$start = strpos( $email_address, "(" );

		if ( FALSE !== $start )
		{
			$end = strpos( $email_address, ")", $start );

			$standard  = substr( $email_address, 0, $start );
			$standard .= substr( $email_address, $end + 1 );
		}
		
		return $standard;
	}
}
